diff -pruN 5.77.0-2/CMakeLists.txt 5.78.0-0ubuntu1/CMakeLists.txt
--- 5.77.0-2/CMakeLists.txt	2020-12-05 13:02:48.000000000 +0000
+++ 5.78.0-0ubuntu1/CMakeLists.txt	2021-01-02 13:30:31.000000000 +0000
@@ -1,10 +1,10 @@
 cmake_minimum_required(VERSION 3.5)
 
-set(KF5_VERSION "5.77.0") # handled by release scripts
+set(KF5_VERSION "5.78.0") # handled by release scripts
 project(Sonnet VERSION ${KF5_VERSION})
 
 include(FeatureSummary)
-find_package(ECM 5.77.0  NO_MODULE)
+find_package(ECM 5.78.0  NO_MODULE)
 set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
 feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
@@ -24,7 +24,7 @@ include(ECMPoQmTools)
 
 set(EXCLUDE_DEPRECATED_BEFORE_AND_AT 0 CACHE STRING "Control the range of deprecated API excluded from the build [default=0].")
 
-set(REQUIRED_QT_VERSION 5.13.0)
+set(REQUIRED_QT_VERSION 5.14.0)
 option(SONNET_USE_WIDGETS "Build components using Qt5Widgets" ON)
 if(SONNET_USE_WIDGETS)
     find_package(Qt5 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Widgets)
@@ -45,7 +45,7 @@ if(SONNET_USE_WIDGETS)
     add_feature_info(DESIGNERPLUGIN ${BUILD_DESIGNERPLUGIN} "Build plugin for Qt Designer")
 endif()
 
-add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050d00)
+add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050e00)
 if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/po")
     ecm_install_po_files_as_qm(po)
 endif()
diff -pruN 5.77.0-2/debian/changelog 5.78.0-0ubuntu1/debian/changelog
--- 5.77.0-2/debian/changelog	2020-12-22 01:33:37.000000000 +0000
+++ 5.78.0-0ubuntu1/debian/changelog	2021-01-09 09:59:48.000000000 +0000
@@ -1,3 +1,9 @@
+sonnet (5.78.0-0ubuntu1) hirsute; urgency=medium
+
+  * New upstream release (5.78.0)
+
+ -- Rik Mills <rikmills@kde.org>  Sat, 09 Jan 2021 09:59:48 +0000
+
 sonnet (5.77.0-2) unstable; urgency=medium
 
   * Release to unstable.
diff -pruN 5.77.0-2/debian/control 5.78.0-0ubuntu1/debian/control
--- 5.77.0-2/debian/control	2020-12-22 01:31:16.000000000 +0000
+++ 5.78.0-0ubuntu1/debian/control	2021-01-09 09:59:48.000000000 +0000
@@ -8,12 +8,12 @@ Build-Depends: aspell,
                cmake (>= 3.5~),
                debhelper-compat (= 13),
                doxygen,
-               extra-cmake-modules (>= 5.77.0~),
+               extra-cmake-modules (>= 5.78.0~),
                graphviz,
                hspell,
                libaspell-dev,
                libhunspell-dev,
-               libkf5sonnet-dev-bin <cross>,
+               libkf5sonnet-dev-bin (>= 5.78.0~) <cross>,
                libqt5sql5-sqlite,
                libvoikko-dev,
                pkg-config,
@@ -54,7 +54,8 @@ Package: libkf5sonnet-dev-bin
 Section: libdevel
 Architecture: any
 Multi-Arch: foreign
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
 Breaks: libkf5sonnet-dev (<< 5.27.0)
 Replaces: libkf5sonnet-dev (<< 5.27.0)
 Description: spell checking library for Qt, devel binaries
diff -pruN 5.77.0-2/po/uk/sonnet5_qt.po 5.78.0-0ubuntu1/po/uk/sonnet5_qt.po
--- 5.77.0-2/po/uk/sonnet5_qt.po	2020-12-05 13:02:48.000000000 +0000
+++ 5.78.0-0ubuntu1/po/uk/sonnet5_qt.po	2021-01-02 13:30:31.000000000 +0000
@@ -19,6 +19,7 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
+"X-Qt-Contexts: true\n"
 "X-Generator: Lokalize 2.0\n"
 "Plural-Forms: nplurals=4; plural=n==1 ? 3 : n%10==1 && n%100!=11 ? 0 : n"
 "%10>=2 && n%10<=4 && (n%100<10 || n%100>=20) ? 1 : 2;\n"
diff -pruN 5.77.0-2/po/zh_CN/sonnet5_qt.po 5.78.0-0ubuntu1/po/zh_CN/sonnet5_qt.po
--- 5.77.0-2/po/zh_CN/sonnet5_qt.po	2020-12-05 13:02:48.000000000 +0000
+++ 5.78.0-0ubuntu1/po/zh_CN/sonnet5_qt.po	2021-01-02 13:30:31.000000000 +0000
@@ -14,7 +14,7 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: kdeorg\n"
-"PO-Revision-Date: 2020-11-10 15:01\n"
+"PO-Revision-Date: 2021-01-01 14:22\n"
 "Language-Team: Chinese Simplified\n"
 "Language: zh_CN\n"
 "MIME-Version: 1.0\n"
diff -pruN 5.77.0-2/src/core/guesslanguage.cpp 5.78.0-0ubuntu1/src/core/guesslanguage.cpp
--- 5.77.0-2/src/core/guesslanguage.cpp	2020-12-05 13:02:48.000000000 +0000
+++ 5.78.0-0ubuntu1/src/core/guesslanguage.cpp	2021-01-02 13:30:31.000000000 +0000
@@ -52,8 +52,8 @@ public:
 
     void loadModels();
     QList< QChar::Script > findRuns(const QString &text);
-    QList<QString> createOrderedModel(const QString &content);
-    int distance(const QList<QString> &model, const QHash<QString, int> &knownModel);
+    QVector<QString> createOrderedModel(const QString &content);
+    int distance(const QVector<QString> &model, const QHash<QString, int> &knownModel);
     QStringList guessFromTrigrams(const QString &sample, const QStringList &langs);
     QStringList identify(const QString &sample, const QList< QChar::Script > &scripts);
     QString guessFromDictionaries(const QString &sentence, const QStringList &candidates);
@@ -92,12 +92,8 @@ GuessLanguagePrivate::GuessLanguagePriva
         return;
     }
 
-#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
     const QStringList languages = Loader::openLoader()->languages();
     s_knownDictionaries = QSet<QString>(languages.begin(), languages.end());
-#else
-    s_knownDictionaries = Loader::openLoader()->languages().toSet();
-#endif
     QSet<QString> dictionaryLanguages;
     for (const QString &dictName : qAsConst(s_knownDictionaries)) {
         QString languageName = QLocale(dictName).name();
@@ -503,11 +499,7 @@ GuessLanguagePrivate::GuessLanguagePriva
             qCDebug(SONNET_LOG_CORE) << "Unhandled script" << script;
             break;
         }
-#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
         allLanguages.unite(QSet<QString>(names.constBegin(), names.constEnd()));
-#else
-        allLanguages.unite(names.toSet());
-#endif
 
         { // Remove unknown languages
             QStringList pruned;
@@ -618,7 +610,7 @@ QString GuessLanguage::identify(const QS
         return suggestionsList.first();
     }
 
-    qCWarning(SONNET_LOG_CORE) << "Unable to find any suggestion for" << text;
+    qCDebug(SONNET_LOG_CORE) << "Unable to find any suggestion for" << text;
 
     // Not even any suggestions, give up
     return QString();
@@ -658,11 +650,7 @@ void GuessLanguagePrivate::loadModels()
         }
         availableLanguages.insert(iterator.key());
     }
-#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
     QSet<QString> knownLanguages(s_scriptLanguages.constBegin(), s_scriptLanguages.constEnd());
-#else
-    QSet<QString> knownLanguages(s_scriptLanguages.values().toSet());
-#endif
     knownLanguages.subtract(availableLanguages);
     if (!knownLanguages.isEmpty()) {
         qCDebug(SONNET_LOG_CORE) << "Missing trigrams for languages:" << knownLanguages;
@@ -730,7 +718,7 @@ QStringList GuessLanguagePrivate::guessF
 {
     QStringList ret;
 
-    const QList<QString> sampleTrigrams = createOrderedModel(sample);
+    const QVector<QString> sampleTrigrams = createOrderedModel(sample);
 
     // Sort by score
     QMultiMap<int, QString> scores;
@@ -769,29 +757,49 @@ QStringList GuessLanguagePrivate::guessF
     return ret;
 }
 
-QList<QString> GuessLanguagePrivate::createOrderedModel(const QString &content)
+QVector<QString> GuessLanguagePrivate::createOrderedModel(const QString &content)
 {
     QHash<QString, int> trigramCounts;
-    QMultiMap<int, QString> orderedTrigrams;
 
+    //collect trigrams
+    trigramCounts.reserve(content.size() - 2);
     for (int i = 0; i < (content.size() - 2); ++i) {
         QString tri = content.mid(i, 3).toLower();
         trigramCounts[tri]++;
     }
 
-    for (const QString &key : trigramCounts.keys()) {
-        const QChar *data = key.constData();
+    //invert the map <freq, trigram>
+    QVector<QPair<int, QString>> trigramFrequencyList;
+    trigramFrequencyList.reserve(trigramCounts.size());
+
+    auto it = trigramCounts.constBegin();
+    for (; it != trigramCounts.constEnd(); ++it) {
+        const QChar *data = it.key().constData();
         bool hasTwoSpaces = (data[1].isSpace() && (data[0].isSpace() || data[2].isSpace()));
 
         if (!hasTwoSpaces) {
-            orderedTrigrams.insert(-trigramCounts[key], key);
+            const int freq = it.value();
+            const QString& trigram = it.key();
+            trigramFrequencyList.append({freq, trigram});
         }
     }
 
-    return orderedTrigrams.values();
+    //sort descending by frequency
+    std::sort(trigramFrequencyList.begin(), trigramFrequencyList.end(), [](const QPair<int, QString>& a, const QPair<int, QString>& b) {
+        return a.first > b.first;
+    });
+
+
+    QVector<QString> orderedTrigrams;
+    orderedTrigrams.reserve(trigramFrequencyList.size());
+    for (const auto& tri : qAsConst(trigramFrequencyList)) {
+        orderedTrigrams.append(tri.second);
+    }
+
+    return orderedTrigrams;
 }
 
-int GuessLanguagePrivate::distance(const QList<QString> &model, const QHash<QString,
+int GuessLanguagePrivate::distance(const QVector<QString> &model, const QHash<QString,
                                                                             int> &knownModel)
 {
     int counter = -1;
diff -pruN 5.77.0-2/src/core/settings.h 5.78.0-0ubuntu1/src/core/settings.h
--- 5.77.0-2/src/core/settings.h	2020-12-05 13:02:48.000000000 +0000
+++ 5.78.0-0ubuntu1/src/core/settings.h	2021-01-02 13:30:31.000000000 +0000
@@ -58,7 +58,6 @@ public:
 
     void setCurrentIgnoreList(const QStringList &ignores);
     QStringList currentIgnoreList() const;
-    bool ignore(const QString &word);
 
     QStringList clients() const;
     bool modified() const;
diff -pruN 5.77.0-2/src/plugins/hspell/hspelldict.cpp 5.78.0-0ubuntu1/src/plugins/hspell/hspelldict.cpp
--- 5.77.0-2/src/plugins/hspell/hspelldict.cpp	2020-12-05 13:02:48.000000000 +0000
+++ 5.78.0-0ubuntu1/src/plugins/hspell/hspelldict.cpp	2021-01-02 13:30:31.000000000 +0000
@@ -31,9 +31,8 @@ HSpellDict::HSpellDict(const QString &la
     }
 
     QSettings settings(QStringLiteral("KDE"), QStringLiteral("SonnetHSpellPlugin"));
-    m_personalWords
-        = QSet<QString>::fromList(settings.value(QStringLiteral("PersonalWords"),
-                                                 QStringList()).toStringList());
+    const QStringList personalWordsList = settings.value(QStringLiteral("PersonalWords"), QStringList()).toStringList();
+    m_personalWords = QSet<QString>(personalWordsList.begin(), personalWordsList.end());
     QVariantHash replacementMap
         = settings.value(QStringLiteral("Replacements"), QVariant()).toHash();
     for (const QString &key : replacementMap.keys()) {
@@ -123,7 +122,8 @@ bool HSpellDict::addToSession(const QStr
 void HSpellDict::storePersonalWords()
 {
     QSettings settings(QStringLiteral("KDE"), QStringLiteral("SonnetHSpellPlugin"));
-    settings.setValue(QStringLiteral("PersonalWords"), QVariant(m_personalWords.toList()));
+    const QStringList personalWordsList(m_personalWords.begin(), m_personalWords.end());
+    settings.setValue(QStringLiteral("PersonalWords"), QVariant(personalWordsList));
     QVariantHash variantHash;
     for (const QString &key : m_replacements.keys()) {
         variantHash[key] = QVariant(m_replacements[key]);
